

#include <unistd.h>            
#include <fcntl.h>	
#include <netinet/in.h>
#include <arpa/inet.h>		
#include <sys/types.h>
#include <sys/socket.h>                                                                                                   
#include <stdio.h>
#include <string.h>     
#include <stdlib.h>
#include <ctype.h>
#include <sys/time.h>
 
#include <errno.h>                                                                                    

//#define DEBUG_PPP   1
#define DEBUG  0

static unsigned long int  ipstr2long(char *ip_str)
{
	char			buf[6];
	char			*ptr;
	int			i;
	int			count;
	unsigned long int 	ipaddr;
	int	cur_byte;

	ipaddr = (unsigned long int )0;
	for(i = 0;i < 4;i++) {
		ptr = buf;
		count = 0;
		*ptr = '\0';
		while(*ip_str != '.' && *ip_str != '\0' && count < 4) {
			if(!isdigit(*ip_str)) {
				return((unsigned long int )0);
			}
			*ptr++ = *ip_str++;
			count++;
		}
		if(count >= 4 || count == 0) {
			return((unsigned long int )0);
		}
		*ptr = '\0';
		cur_byte = atoi(buf);
		if(cur_byte < 0 || cur_byte > 255) {
			return((unsigned long int )0);
		}
		ip_str++;
		ipaddr = ipaddr << 8 | (unsigned long int )cur_byte;
	}
	return(ipaddr);
}

#define PPPOPTIONFILE "/etc/ppp/options.ttyBT"


#define NUMBT 		7
#define ADD 		0
#define RELEASE 	1
#define LOCALIP 	"127.0.0.1"
#define PORTIPSERVER 71
#define WAITINGTIME 	100
#define ADDTAG 	"ADD"
#define RELEASETAG 	"RELEASE"
#define PORTTAG 	"PORT="
#define LINETAG 	"LINE= "
#define BUFSIZE 	256
#define ACK "ACK"

static int IsAddrRecord(char *buf) {
	int npoint=0;
	int i=0;

	if ( ! index (buf,':' )  ) return 0;
	for(i=0;i<strlen(buf);i++ ) { if ( buf[i] == '.') npoint++; }

#ifdef DEBUG_PPP
		if ( npoint != 6 ) printf("%s is not a valid addr !!!!\n",buf) ;
#endif
	if ( npoint == 6 ) return 1;
	return 0;

}


static int updatepppconfig(char *buf,int numread,int numline,int code) {
	FILE *fd;
	char filename[BUFSIZE];
	char tmp[BUFSIZE];
	char *ptr=NULL;
	int sizef=0,sizel=0;
	

#ifdef DEBUG
	printf("try to update ppp config file for line %d\n",numline);
#endif
	sprintf(filename,"%s%d",PPPOPTIONFILE,numline);
	fd=fopen(filename,"r");
	if ( fd == NULL ) {
#ifdef DEBUG_PPP
		printf("Failed to open ppp config file\n");
#endif
		 return -1;
	}
	if ( code == RELEASE ) while(fgets(tmp,BUFSIZE,fd) ) {  sizel=strlen(tmp); sizef = sizef + sizel ;}

	fclose(fd);

	if ( code == ADD ){
	        char *temp = buf;

		fd=fopen(filename,"a+");
		if ( fd == NULL ) return -1;
		buf[numread+1] = 0;
		buf[numread] = '\n';
		while ((temp=strstr(temp,"ms-dns")) != NULL) {
		  if ((temp-buf-1) >= 0)
		    *(temp-1) = '\n';
		  temp +=6;
		}
		ptr=buf+strlen(ACK)+1;
		if  ( fputs(ptr,fd)  == EOF ) {
			fclose(fd);
			return -1;
		}
		fclose(fd);
	return 0;
	}


	if ( code == RELEASE && IsAddrRecord(tmp)  ){
#ifdef DEBUG_PPP
		printf("Cutting %s in file %s\n",tmp,filename);
#endif
		if ( truncate(filename, (sizef-sizel)) != 0 ) return -1;
		return 0;
	}
	
	return 0;

}



int get_ip_from_network(char *hw,int numline,int code,char *pppdopt) {
	
	int 			socksend;
	int 			flags,local_port,total_length,salen,numread,nonblock;
	struct sockaddr		salocal;
	struct sockaddr_in 	*sin_local;

	struct	sockaddr	saremote;
	struct	sockaddr_in	*sin_remote;

	struct	sockaddr	safromserver;
	struct	sockaddr_in	*sin_fromserver;

	fd_set			readfds;
	char 			buf[BUFSIZE];
 	struct timeval		tv;

	if ( numline < 0 || numline > NUMBT ) return 0;
	if ( hw == NULL ) return 0;


	
	socksend = socket (AF_INET, SOCK_DGRAM, IPPROTO_UDP);

	if  ( socksend == -1 ) return 0;
 	nonblock=1;
	/*if (setsockopt (socksend , SOL_SOCKET, SO_REUSEADDR, &nonblock, sizeof (nonblock)) == 0) {
		if ((flags = fcntl (socksend , F_GETFL, 0)) >=0) {
   			fcntl (socksend , F_SETFL, flags | O_NONBLOCK);
		}
		else {
			printf("Unable to configure Socket \n");
		}
	}*/

	sin_local = (struct sockaddr_in *) &salocal;
  	memset (sin_local, 0, sizeof (salocal));
  	sin_local->sin_family = AF_INET;
  //	sin_local->sin_addr.s_addr=htonl( ipstr2long(LOCALIP));
  	sin_local->sin_addr.s_addr=inet_addr("127.0.0.1");
	local_port = 1025;
	do {
		local_port++;
		sin_local->sin_port = htons((u_short)local_port);
	} while((bind(socksend, &salocal, sizeof (struct sockaddr_in)) < 0) && local_port < 64000);

	if (local_port >= 64000) {
		close(socksend);
		return 0;
	}

	switch(code) {
		case ADD:
				sprintf(buf,"%s%d %s %s%d %s",PORTTAG,local_port,ADDTAG,LINETAG,numline,hw);
				break;
		case RELEASE:
				sprintf(buf,"%s%d %s %s%d %s",PORTTAG,local_port,RELEASETAG ,LINETAG,numline,hw);
				break;
		default:
				return 0;
	}
	total_length=strlen(buf);

	sin_remote = (struct sockaddr_in *) &saremote;
  	memset (sin_remote, 0, sizeof (saremote));
  	sin_remote->sin_family = AF_INET;
  	sin_remote->sin_addr.s_addr=htonl( ipstr2long(LOCALIP));
	sin_remote->sin_port = htons ((u_short)PORTIPSERVER);




  if ( sendto(socksend, (char *)buf, total_length, 0,&saremote, sizeof(struct sockaddr_in)) == -1 ) {
		close(socksend);
		return 0;
	}

	tv.tv_sec = WAITINGTIME;
 	tv.tv_usec = 0;
 	FD_ZERO(&readfds);
 	FD_SET(socksend, &readfds);

 	 if (select(socksend+1,&readfds, NULL, NULL, &tv) == 0) {
		printf("Select PB \n");
		close(socksend);
		return 0;
	}
	sin_fromserver= (struct sockaddr_in *) &safromserver;
  	memset (sin_fromserver, 0, sizeof (safromserver));

	salen=sizeof(struct sockaddr );

	numread = recvfrom (socksend,(char *)buf,BUFSIZE,0,&safromserver, &salen);
	if ( numread < 0 ) {
		perror("recvfrom Pb ");
		printf("receving -1 bytes of port %d \n",ntohs(sin_fromserver->sin_port) );
		close(socksend);
		return 0;
	}
	buf[numread] = 0;
	if ( strstr(buf,ACK) ) {
#ifdef DEBUG
		if ( code == ADD ) printf("Reception des adresses %s pour la ligne %d (%d) \n",buf+strlen(ACK),numline,ntohs(sin_fromserver->sin_port) );
		if ( code == RELEASE ) printf("Suppression pour la ligne %d effectuee (%d) \n",numline,ntohs(sin_fromserver->sin_port) );	
#endif
	}
	else {
		printf("unknown answer %s\n",buf);
		return 0;
	}

	  
	close(socksend);
	//majppp = updatepppconfig(buf,numread,numline,code);
	if (code == ADD) {
	  buf[numread] = 0;
	  strcpy(pppdopt,buf+strlen(ACK)+1);
	}
	
	//majppp     = majppp+10;
	return 10;

}




#ifdef TESTMODE

#define USAGE    "
Usage: %s [-h hardwareID ] [-l linenum ] -c code
 Where
   -w means used hardwareID instead of default %s hardwareDef
   -l means used lineport instead of default %d linenum
   -c specify code for DHCP request ( 0 ADD, 1 RELEASE )\n"

int main(int argc,char *argv[])
{
	
	char hw[BUFSIZE];
	int i,lin=0;
	int code=-1;
	int errcode;
	char pppd_opt[256];
	strcpy(hw,"00:00:00:00:00:00");

	for ( i = 1; i < argc; i ++ )
   	 {
      		if ( argv[i][0] == '-' ) {
 			if ( strcmp( &argv[i][1], "c" ) == 0 ) {
				i++;
				if ( i == argc ) {
					printf( USAGE, argv[0],hw,lin);
					return 1;
				}
				code = atoi(argv[i]);
             		}
         			else if ( strcmp( &argv[i][1], "l" ) == 0 ) {
				i++;
				if ( i == argc ) {
					printf( USAGE, argv[0],hw,lin);
					return 1;
				}
				lin=atoi(argv[i]);
              		}
         			else if ( strcmp( &argv[i][1], "w" ) == 0 ) {
				i++;
				if ( i == argc ) {
					printf( USAGE, argv[0],hw,lin);
					return 1;
				}
				strcpy(hw,argv[i] );
			}
                   		else if ( strcmp( &argv[i][1], "h" ) == 0 ) {
				printf( USAGE, argv[0],hw,lin);
				return 1;
			}
		}

	}  

	if ( code < ADD || code > RELEASE ) {
		printf("No code specify exiting \n");
		return 0;
	}
	errcode =  get_ip_from_network(hw,lin,code,pppd_opt);
	if ( errcode == 10 ) {
		printf(" Update PPP option file succeeded on line %d \npppd cmds %s\n",lin,pppd_opt);
	}
	else if (  errcode == 9 ) {
		printf(" Unable to update  PPP option file on line %d \n",lin);
		return 0;
	}
	else if (  errcode < 9 )   {
		printf(" Communication Pb on line %d \n",lin);
		/*
		if ( code == RELEASE ){
				if (  updatepppconfig(NULL,0,lin,code) == -1 )  {
					printf("but failed to clean-up ppp option \n");
				}
				else {
					printf("ppp option clean-up \n");
				}
		}
		*/
		return 0;
 }

	return 1;
}

#endif





















